'''A Class for D&D 3.5 Mod

To do:
    Finish Powers
    Play Test Eveything'''

import es, dnd, popuplib, math, gamethread, playerlib, random
from dnd import dnd

SpellCommands = []

def load():
    dnd.addClass('Psion', dnd.Pistols+['knife'])

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnd/SubScripts/Psion/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnd/SubScripts/Psion/%s'%command)
    
    dnd.Commands['cast']['Classes'].append('Psion')

    psioninfo = popuplib.create('psioninformation')
    psioninfo.addline('-{ D&D CS:S - Psion}-')
    psioninfo.addline(' Weapons: Pistols')
    psioninfo.addline(' Enter \'cast\' into chat for a casting menu')
    psioninfo.addline(' Or enter the (keyword) listed to directly cast a spell')
    psioninfo.addline('-> 1. Low Level Spells')
    psioninfo.addline('-> 2. Meduim Level Spells')
    psioninfo.addline('-> 3. High Level Spells')
    psioninfo.addline('-> 7. Play as a Psion')
    psioninfo.addline('-> 8. Back')
    psioninfo.addline('0. Exit')
    psioninfo.submenu(1, 'psion spinfo 1')
    psioninfo.submenu(2, 'psion spinfo 2')
    psioninfo.submenu(3, 'psion spinfo 3')
    psioninfo.submenu(8, 'classinfo 1')
    psioninfo.menuselect = psionMenuSelect
    dnd.addClassInformation('Psion', 'psioninformation')

    psioncast = popuplib.create('Psioncast')
    psioncast.addline('-{ Psion Cast XPP }-')
    psioncast.addline('-> 1. Magic Missile')
    psioncast.addline('-> 2. Disguise Self')
    psioncast.addline('-> 3. Protection from Bullets')
    psioncast.addline('-> 4. Fireball')
    psioncast.addline('-> 5. Haste')
    psioncast.addline('-> 6. Animate Dead')
    psioncast.addline('-> 7. Scrying')
    psioncast.addline('-> 8. Chain Lightning')
    psioncast.addline('-> 9. High Level Spells')
    psioncast.addline('0. Exit')
    psioncast.prepuser = psionCastPrep
    psioncast.menuselect = psionCast

    psioncast2 = popuplib.create('PsioncastHigh')
    psioncast2.addline('-{ Psion High Lvl Castings }-')
    psioncast2.addline('-> 1. Mass Invisibility')
    psioncast2.addline('-> 2. Create Greater Undead')
    psioncast2.addline('-> 3. Time Stop')
    psioncast2.addline('-> 9. Low Level Spells')
    psioncast2.addline('0. Exit')
    psioncast2.submenu(9, 'Psioncast')
    psioncast2.prepuser = psionCastPrepHigh
    psioncast2.menuselect = psionCastHigh

    spinfo1 = popuplib.create('psion spinfo 1')
    spinfo1.addline('-{ Psion - Low - Spells }-')
    spinfo1.addline(' Magic Missile (lvl 1)')
    spinfo1.addline('  - Damage selected player (missile)')
    spinfo1.addline(' Disguise Self (lvl 1)')
    spinfo1.addline('  -  Appear as the opposite team for a time (disguise)')
    spinfo1.addline(' Protection from Bullets (lvl 3)')
    spinfo1.addline('  -  Selected player gains huge damage reduction for a short time (protection)')
    spinfo1.addline(' Fire Ball (lvl 5)')
    spinfo1.addline('  -  Damage and maybe burn your target and those around them (fire)')
    spinfo1.addline('-> 8. Back')
    spinfo1.addline('0. Exit')
    spinfo1.submenu(8, 'psioninformation')
    
    spinfo2 = popuplib.create('psion spinfo 2')
    spinfo2.addline('-{ Psion - Medium - Spells }-')
    spinfo2.addline(' Haste (lvl 7)')
    spinfo2.addline('  -  Selected player gains a large speed boost (haste)')
    spinfo2.addline(' Animate Dead (lvl 9)')
    spinfo2.addline('  - Raise selected ally as a zombie (500$) (animate)')
    spinfo2.addline(' Scrying (lvl 11)')
    spinfo2.addline('  - Locate nearby enemies for a duration (scry)')
    spinfo2.addline(' Chain Lightning (lvl 13)')
    spinfo2.addline('  - Damage target and link into nearby enemies (chain)')
    spinfo2.addline('-> 8. Back')
    spinfo2.addline('0. Exit')
    spinfo2.submenu(8, 'psioninformation')
    
    spinfo3 = popuplib.create('psion spinfo 3')
    spinfo3.addline('-{ Psion - High - Spells }-')
    spinfo3.addline(' Mass Invisibility (lvl 15)')
    spinfo3.addline('  -  Yourself and all nearby allies vanish fron sight (massinvis)')
    spinfo3.addline(' Create Greater Undead (lvl 17)')
    spinfo3.addline('  -  Raise all dead allies as Shadows (undead)')
    spinfo3.addline(' Time Stop (lvl 19)')
    spinfo3.addline('  -  *Pause* all other players for 5 seconds (time)')
    spinfo3.addline('-> 8. Back')
    spinfo3.addline('0. Exit')
    spinfo3.submenu(8, 'psioninformation')

ef psionCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'missile')
    elif choice == 2:
        es.cexec(userid, 'disguise')
    elif choice == 3:
        es.cexec(userid, 'protection')
    elif choice == 4:
        es.cexec(userid, 'fire')
    elif choice == 5:
        es.cexec(userid, 'haste')
    elif choice == 6:
        es.cexec(userid, 'animate')
    elif choice == 7:
        es.cexec(userid, 'scry')
    elif choice == 8:
        es.cexec(userid, 'chain')
    elif choice == 9 and dnd.getLevel(userid, 'Psion') >= 15:
        dnd.popupSend('PsioncastHigh', userid)
    elif choice == 9 and dnd.Bank(userid)['prestige']:
        dnd.popupSend('%scast'%dnd.Bank(userid)['prestige'], userid)

def psionCastPrep(userid, popupid):
    popup = popuplib.find('Psioncast')
    level = dnd.getLevel(userid, 'Psion')
    Key = dnd.getPlayer(userid)
    ID = dnd.Bank(userid)
    prestige = ID['prestige']
    popup.modline(1, '-{ Psion Cast - %sL - %sM }-'%(Key['spells'][1], Key['spells'][2]))
    if Key['spells'][1] < 1:
        popup.modline(2, ' Magic Missile')
        popup.modline(3, ' Disguise Self')
    else:
        popup.modline(2, '-> 1. Magic Missile 1L')
        popup.modline(3, '-> 2. Disguise Self 1L')
    if level < 3:
        popup.modline(4, '')
    else:
        if Key['spells'][1] < 3:
            popup.modline(4, ' Protection from Bullets')
        else:
            popup.modline(4, '-> 3. Protection from Bullets 3L')
    if level < 5:
        popup.modline(5, '')
    else:
        if Key['spells'][1] < 3:
            popup.modline(5, ' Fireball')
        else:
            popup.modline(5, '-> 4. Fireball 3L')
    if level < 7:
        popup.modline(6, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(6, ' Haste')
        else:
            popup.modline(6, '-> 5. Haste 2M')
    if level < 9:
        popup.modline(7, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(7, ' Animate Dead')
        else:
            popup.modline(7, '-> 6. Animate Dead 2M')
    if level < 11:
        popup.modline(8, '')
    else:
        if Key['spells'][2] < 1:
            popup.modline(8, ' Scrying')
        else:
            popup.modline(8, '-> 7. Scrying 1M')
    if level < 13:
        popup.modline(9, '')
    else:
        if Key['spells'][2] < 3:
            popup.modline(9, ' Chain Lightning')
        else:
            popup.modline(9, '-> 8. Chain Lightning 3M')
    if level < 15:
        popup.modline(10, '')
    else:
        popup.modline(10, '-> 9. High Level Spells')
    if prestige:
        popup.modline(10, '-> 9. Prestige Spells')

def psionCastHigh(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'massinvis')
    elif choice == 2:
        es.cexec(userid, 'undead')
    elif choice == 3:
        es.cexec(userid, 'time')

def psionCastPrepHigh(userid, popupid):
    popup = popuplib.find('PsioncastHigh')
    level = dnd.getLevel(userid, 'Psion')
    Key = dnd.getPlayer(userid)
    if level < 15:
        popup.modline(2, '')
    else:
        if Key['spells'][3] < 3:
            popup.modline(2, ' Mass Invisibility')
        else:
            popup.modline(2, '-> 1. Mass Invisibility')
    if level < 17:
        popup.modline(3, '')
    else:
        if Key['spells'][3] < 3:
            popup.modline(3, ' Create Greater Undead')
        else:
            popup.modline(3, '-> 2. Create Greater Undead')
    if level < 19:
        popup.modline(4, '')
    else:
        if Key['spells'][3] < 3:
            popup.modline(4, ' Time Stop')
        else:
            popup.modline(4, '-> 3. Time Stop')
